<s:div xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:h="http://java.sun.com/jsf/html"
       xmlns:a4j="http://richfaces.org/a4j" xmlns:g="http://www.ihe.net/gazelle" xmlns:f="http://java.sun.com/jsf/core"
       xmlns:gri="http://java.sun.com/jsf/composite/gri" xmlns:rich="http://richfaces.org/rich" xmlns:gdk="http://www.ihe.net/gazellecdk"
       xmlns="http://www.w3.org/1999/xhtml">
  <table width="100%" class="rf-dt">
    <thead class="rf-dt-thd">
    <tr class="rf-dt-shdr">
      <th class="rf-dt-shdr-c">
        <b>#{messages['net.ihe.gazelle.xdstar.Opt']}</b>
      </th>
      <th class="rf-dt-shdr-c">
        <b>#{messages['net.ihe.gazelle.xdstar.MetadataName']}</b>
      </th>
      <th class="rf-dt-shdr-c" colspan="2">
        <b>#{messages['net.ihe.gazelle.xdstar.Values']})</b>
      </th>
    </tr>
    </thead>
    <tbody class="rf-dt-b">
    <a4j:repeat value="#{pnrIHEManager.selectedXDSDocumentEntry.externalIdentifier}" var="m">
      <tr class="rf-dt-r rf-dt-fst-r">
        <td class="rf-dt-c">
          #{pnrIHEManager.getOptionalityExtOnSelectedXDSDocumentEntry(m)}
        </td>
        <td class="rf-dt-c">
          <h:panelGrid columns="3">
            <h:outputText value="#{pnrIHEManager.getDisplayNameExt(m)}"/>
            <gdk:spacer width="5"/>
            <a4j:commandLink actionListener="#{pnrIHEManager.removeExtFromSelectedXDSDocumentEntry(m)}"
                             render="metadata_id"
                             execute="@this"
                             rendered="#{pnrIHEManager.getOptionalityExtOnSelectedXDSDocumentEntry(m).equals('O')}">
              <span class="gzl-icon-minus"/>
            </a4j:commandLink>
          </h:panelGrid>
        </td>
        <td class="rf-dt-c" colspan="2">
          <h:inputText value="#{m.value}" size="70" maxlength="255" styleClass="form-control"/>
        </td>
      </tr>
    </a4j:repeat>
    <!-- slot  -->
    <a4j:repeat value="#{pnrIHEManager.selectedXDSDocumentEntry.slot}" var="m">
      <tr class="rf-dt-r">
        <td class="rf-dt-c">
          #{pnrIHEManager.getOptionalitySlotOnSelectedXDSDocumentEntry(m)}
        </td>
        <td class="rf-dt-c">
          <h:panelGrid columns="3">
            <h:outputText value="#{m.name}"/>
            <gdk:spacer width="5"/>
            <a4j:commandLink actionListener="#{pnrIHEManager.removeSlotFromSelectedXDSDocumentEntry(m)}"
                             render="metadata_id"
                             execute="@this"
                             rendered="#{pnrIHEManager.getOptionalitySlotOnSelectedXDSDocumentEntry(m).equals('O')}">
              <span class="gzl-icon-minus"/>
            </a4j:commandLink>
          </h:panelGrid>
        </td>
        <td class="rf-dt-c" colspan="2">
          <ui:include src="slot.xhtml">
            <ui:param name="slot" value="#{m}"/>
          </ui:include>
        </td>
      </tr>
    </a4j:repeat>
    <!-- classifications -->
    <a4j:repeat value="#{pnrIHEManager.selectedXDSDocumentEntry.classification}" var="m">
      <tr class="rf-dt-r">
        <td class="rf-dt-c" rowspan="#{pnrIHEManager.rownSpanClass(m)}">#{pnrIHEManager.getOptionalityClassOnSelectedXDSDocumentEntry(m)}</td>
        <td class="rf-dt-c" rowspan="#{pnrIHEManager.rownSpanClass(m)}">
          <h:panelGrid columns="3">
            <h:outputText value="#{pnrIHEManager.getDisplayNameClass(m)}"/>
            <gdk:spacer width="5"/>
            <a4j:commandLink actionListener="#{pnrIHEManager.removeClassificationFromSelectedXDSDocumentEntry(m)}"
                             render="metadata_id"
                             execute="@this"
                             rendered="#{pnrIHEManager.getOptionalityClassOnSelectedXDSDocumentEntry(m).equals('O')}">
              <span class="gzl-icon-minus"/>
            </a4j:commandLink>
          </h:panelGrid>
        </td>
        <a4j:region rendered="#{!pnrIHEManager.isValueSet(m)}">
          <td class="rf-dt-c">#{messages['net.ihe.gazelle.xdstar.DisplayName']}</td>
          <td class="rf-dt-c">
            <a4j:repeat value="#{m.name.localizedString}" var="name">
              <h:panelGrid columns="3">
                <h:outputText value="#{name.value}"/>
                <gdk:spacer width="5"/>
                <a4j:commandLink actionListener="#{m.name.localizedString.remove(name)}"
                                 render="metadata_id"
                                 execute="@this">
                  <span class="gzl-icon-minus"/>
                </a4j:commandLink>
              </h:panelGrid>
            </a4j:repeat>
            <a4j:commandLink actionListener="#{pnrIHEManager.initSelectedInternationalStringType(m)}"
                             oncomplete="jq162('#AddNameValue').modal('show');"
                             render="AddNameValueForm,AddNameValue"
                             rendered="#{pnrIHEManager.canAddName(m.name)}">
              <span class="gzl-icon-plus"/>
            </a4j:commandLink>
          </td>
        </a4j:region>
        <a4j:region rendered="#{pnrIHEManager.isValueSet(m)}">
          <td class="rf-dt-c" colspan="2">
            <h:selectOneMenu value="#{m.nodeRepresentation}" styleClass="form-control gzl-form-control gzl-select-text">
              <f:selectItems value="#{pnrIHEManager.listValueSet(m)}" noSelectionLabel="#{messages['net.ihe.gazelle.xdstar.PleaseSelect']}"/>
              <a4j:ajax event="change" listener="#{pnrIHEManager.updateClassificationByValueSet(m)}"/>
            </h:selectOneMenu>
          </td>
        </a4j:region>
      </tr>
      <a4j:region rendered="#{!pnrIHEManager.isValueSet(m)}">
        <!-- For some specification version, for example XDSDocumentEntry.author, the node representation shall be empty -->
        <!-- If this changes, juste remove this condition -->
        <s:div rendered="#{!pnrIHEManager.shouldNodeRepresentationBeLetEmpty(m)}">
          <tr class="rf-dt-r">
            <td class="rf-dt-c">#{messages['net.ihe.gazelle.xdstar.Code']}</td>
            <td class="rf-dt-c">
              <h:inputText value="#{m.nodeRepresentation}" styleClass="form-control"/>
            </td>
          </tr>
        </s:div>
        <a4j:repeat value="#{m.slot}" var="slot">
          <tr class="rf-dt-r">
            <td class="rf-dt-c">
              <h:panelGrid columns="3">
                <h:outputText value="#{slot.name}"/>
                <gdk:spacer width="5"/>
                <a4j:commandLink actionListener="#{m.slot.remove(slot)}"
                                 render="metadata_id"
                                 execute="@this"
                                 rendered="#{pnrIHEManager.getOptionalitySlotOnClassification(slot, m).equals('O')}">
                  <span class="gzl-icon-minus"/>
                </a4j:commandLink>
              </h:panelGrid>
            </td>
            <td class="rf-dt-c">
              <ui:include src="slot.xhtml">
                <ui:param name="slot" value="#{slot}"/>
              </ui:include>
            </td>
          </tr>
        </a4j:repeat>
        <a4j:region rendered="#{pnrIHEManager.hasOptionalSlotYet(m)}">
          <tr class="rf-dt-r">
            <td class="rf-dt-c" colspan="2">
              <a4j:commandLink actionListener="#{pnrIHEManager.setSelectedClassificationType(m)}"
                               value="#{messages['net.ihe.gazelle.xdstar.AddOptionalMetadataRelatedTo']} #{pnrIHEManager.getDisplayNameClass(m)}"
                               oncomplete="jq162('#ClassificationSlotOptional').modal('show')"
                               render="ClassificationSlotOptionalForm"/>
            </td>
          </tr>
        </a4j:region>
      </a4j:region>
    </a4j:repeat>
    </tbody>
  </table>
</s:div>